VERSION 5.00
Begin VB.Form frmMain 
   Caption         =   "Serial Board Sample Application"
   ClientHeight    =   4575
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   5415
   LinkTopic       =   "Form1"
   ScaleHeight     =   305
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   361
   StartUpPosition =   3  'Windows Default
   Begin VB.Frame frameDigital 
      Caption         =   "Digital"
      Height          =   2295
      Left            =   120
      TabIndex        =   1
      Top             =   2160
      Width           =   5175
      Begin VB.CommandButton cmdResetCount 
         Caption         =   "Reset Count"
         Height          =   375
         Left            =   2400
         TabIndex        =   3
         Top             =   1800
         Width           =   1455
      End
      Begin VB.CommandButton cmdIncrementCount 
         Caption         =   "Increment Count"
         Height          =   375
         Left            =   720
         TabIndex        =   2
         Top             =   1800
         Width           =   1455
      End
      Begin VB.Label lblCount 
         BackColor       =   &H80000018&
         Height          =   255
         Left            =   2400
         TabIndex        =   10
         Top             =   1200
         Width           =   735
      End
      Begin VB.Label Label4 
         BackColor       =   &H80000018&
         Caption         =   " Event Count:  "
         Height          =   255
         Left            =   1320
         TabIndex        =   9
         Top             =   1200
         Width           =   1095
      End
      Begin VB.Label Label3 
         Caption         =   "-- Events are tallied, posted to the screen, and written to Port 3"
         Height          =   255
         Left            =   240
         TabIndex        =   8
         Top             =   480
         Width           =   4455
      End
      Begin VB.Label Label2 
         Caption         =   "-- Hardware events are enabled on Port 2 Bit 0"
         Height          =   255
         Left            =   240
         TabIndex        =   7
         Top             =   240
         Width           =   3975
      End
      Begin VB.Label Label6 
         Caption         =   "-- Can also increment event count or reset it by clicking the buttons"
         Height          =   255
         Left            =   240
         TabIndex        =   13
         Top             =   720
         Width           =   4815
      End
   End
   Begin VB.Frame frameAnalog 
      Caption         =   "Analog"
      Height          =   1815
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   5175
      Begin VB.CommandButton cmdStopPolling 
         Caption         =   "Stop Polling"
         Height          =   375
         Left            =   2520
         TabIndex        =   6
         Top             =   1320
         Width           =   1215
      End
      Begin VB.CommandButton cmdStartPolling 
         Caption         =   "Start Polling"
         Height          =   375
         Left            =   960
         TabIndex        =   5
         Top             =   1320
         Width           =   1215
      End
      Begin VB.Label Label5 
         Caption         =   "-- Polling an analog channel"
         Height          =   255
         Left            =   240
         TabIndex        =   12
         Top             =   240
         Width           =   2775
      End
      Begin VB.Shape Shape1 
         FillColor       =   &H000000FF&
         FillStyle       =   0  'Solid
         Height          =   255
         Left            =   240
         Top             =   840
         Width           =   4455
      End
      Begin VB.Label Label1 
         Caption         =   "Port 1, Channel 0:"
         Height          =   255
         Left            =   240
         TabIndex        =   4
         Top             =   600
         Width           =   1455
      End
      Begin VB.Label lblAnalog 
         Height          =   255
         Left            =   1680
         TabIndex        =   11
         Top             =   600
         Width           =   615
      End
   End
   Begin VB.Timer Timer1 
      Left            =   4920
      Top             =   1920
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim WithEvents board As ser_sr24       'declare object variable for serial board
Attribute board.VB_VarHelpID = -1

Dim event_count As Long               'holds the hardware event count

Private Sub board_HardwareEvent(ByVal id As Long, ByVal value As Long)
    'This routine is automatically called when a hardware event occurs
    'Parameters:  id - this is the id of the event which occurred
    '             value - this is the value of the event ( value on the pin(s) )
    
    event_count = event_count + 1
    If event_count > 255 Then event_count = 0
    
    Call board.OutputByte(3, event_count)
        
    'Update screen
    lblCount.Caption = event_count
    
End Sub

Private Sub cmdIncrementCount_Click()
    event_count = event_count + 1
    If event_count > 255 Then event_count = 0
    
    'Write the count to Port 3
    Call board.OutputByte(3, event_count)
    
    'Update screen
    lblCount.Caption = event_count
    
End Sub

Private Sub cmdResetCount_Click()
    'Reset the event counter
    event_count = 0
    
    'Update the screen
    lblCount.Caption = event_count
    
    'Write the count to Port 3
    Call board.OutputByte(3, event_count)

End Sub

Private Sub cmdStartPolling_Click()
    'To start polling, activate the timer control.  First, set the timer interval
    'to your desired polling period. For example, setting the timer interval to 100
    'will cause the timer to trigger the timer event procedure every 100 ms.
    'Our polling code is in the timer event procedure.

    'Set polling interval to 40 ms
    Timer1.Interval = 40
    
    'Activate timer
    Timer1.Enabled = True

End Sub

Private Sub cmdStopPolling_Click()
    'To stop polling, just disable the timer.  This will prevent the timer
    'event procedure from being called.
    
    'Disable the timer
    Timer1.Enabled = False
    
End Sub

Private Sub Form_Load()
    'This code is executed when the form is loaded
    'Here we will do some initialization
    
    'Declare variables
    Dim result As Long          'holds function return codes
    Dim ser_port As String      'holds name of serial port to use
    Dim baud_rate As BaudRate   'baud rate at which to connect
    
    
    '********************************************
    ' Configuration
    '********************************************
    ser_port = "COM1"
    baud_rate = SER_9600
    '********************************************
    
    'Initialize object variable for serial board
    Set board = New ser_sr24
    
    'Open connection to the board
    result = board.OpenBoard(ser_port, baud_rate)
    If result <> 0 Then
        'Error opening board
        MsgBox board.ErrorString(result)
        End
    End If
    
    
    'Configure the serial board ports to work for this example
        'Port 1 --> Analog mode
        result = board.SetPortMode(1, SR24_TYPE, SR24_TYPE_ANALOG)
        If result <> 0 Then
            MsgBox board.ErrorString(result)
            End
        End If
            
        'Port 2 --> Digital mode, Input
        result = board.SetPortMode(2, SR24_BUFFER, SR24_DIRECTION_INPUT)
        If result <> 0 Then
            MsgBox board.ErrorString(result)
            End
        End If
        
        'Port 3 --> Digital mode, Output
        result = board.SetPortMode(3, SR24_DIRECTION, SR24_DIRECTION_OUTPUT)
        If result <> 0 Then
            MsgBox board.ErrorString(result)
            End
        End If
    
    'Enable hardware events on Port 2 Bit 0; assign an id of 200 to this event
        result = board.RegisterEvent(2, 0, 200)
        
End Sub

Private Sub Form_Unload(Cancel As Integer)
    'This code is executed when the form is unloaded
    'We do cleanup tasks here
    
    'Destroy object variable if we have not already done so
    '(this automatically closes the serial board connection as well)
    If IsObject(board) Then
        Set board = Nothing
    End If

End Sub

Private Sub Timer1_Timer()
    'This is the timer event procedure.  This gets called every timer the timer
    'goes off.  Here we poll an analog input of the serial board and update the
    'value and the bar graph on the screen to match the analog value.
    
    'Declare variables
    Dim result As Long          'result of the function call
    Dim value As Long           'holds value read from the channel

    result = board.InputAnalog(0, value)
    
    'Update value on screen and the bar graph
    lblAnalog.Caption = value
    Shape1.Width = (value / 1023) * 300 * Screen.TwipsPerPixelX
    
End Sub
